from cymath.vector3 cimport Vector3
from cymath.matrix4 cimport Matrix4

cdef class _AstroState:
    cdef double _time
    cdef Vector3 _position
    cdef Vector3 _velocity
    
cdef class ECI(_AstroState):
    cpdef RIC to_ric(self, ECI chief)
    cpdef Matrix4 eci_to_ric(self)
    
cdef class EFG(_AstroState):
    cpdef ECI to_eci(self)
    cpdef LLH to_llh(self)

cdef class RIC(_AstroState):
    cpdef ECI to_eci(self, ECI chief)

cdef class LLH(Vector3):
    cpdef Vector3 to_efg(self)