from cymath.vector3 cimport Vector3
#Based on PyKEP Lambert_Problem.h / Lambert_Problem.cpp
cdef class LambertProblem:
    cdef Vector3 _r1
    cdef Vector3 _r2
    cdef object _v1 #List of Vector3
    cdef object _v2 #List of Vector3
    cdef object _iters #List of int
    cdef object _x #list of double
    cdef double _s #s... ? ((r2-r1).magnitude + r1.magnitude() + r2.magnitude()) / 2.0
    cdef double _c #chord length
    cdef double _lambda
    cdef double _mu
    cdef double _tof
    cdef int _n_max
    cdef int _max_revs
    cdef bint _is_prograde
    cdef bint _has_converged
    
    cdef _dTdx(self, double& DT, double& DDT, double& DDDT, double x, double T)
    cdef double _hypergeometricF(self, double z, double tol)
    cdef void _x2tof2(self, double& tof, double x, int N)
    cdef void _x2tof(self, double& tof, double x, int N)
    cdef int _householder(self, double T, double& x0, int n, double eps, int max_iters)
#
##include <boost/math/special_functions/acosh.hpp>
##include <boost/math/special_functions/asinh.hpp>
#
##include "lambert_problem.h"
##include "core_functions/array3D_operations.h"
##include"exceptions.h" 
#/** Constructs and solves a Lambert problem.
#*
#* \param[in] R1 first cartesian position
#* \param[in] R2 second cartesian position
#* \param[in] tof time of flight
#* \param[in] mu gravity parameter
#* \param[in] cw when 1 a retrograde orbit is assumed
#* \param[in] multi_revs maximum number of multirevolutions to compute
#*/  
#lambert_problem::lambert_problem(const array3D &r1, const array3D &r2, const double &tof, const double& mu, const int &cw, const int &multi_revs) :
#   m_r1(r1), m_r2(r2),m_tof(tof),m_mu(mu),m_has_converged(true), m_multi_revs(multi_revs)
#cdef object lambert_pykep(Vector3 r1, Vector3 r2, double tof, double mu, bint is_prograde, int max_revs):
#    
#    if tof <= 0:
#        print "Error: Time of Flight is negative"
#        
#    if mu <= 0:
#        print "Gravity Parameter is zero or negative"
#        
#    
#    cdef double m_s
#    cdef double m_c
    
    