from cymath.vector3 cimport Vector3
from cymath.quaternion cimport Quaternion

cdef class Rigidbody:
    cdef double _mass
    cdef Vector3 _position
    cdef Vector3 _velocity
    cdef Vector3 _acceleration
    cdef Quaternion _attitude
    cdef Quaternion _angular_velocity
    cdef Quaternion _angular_acceleration

    cpdef void update_rk4(Rigidbody self, double sim_time, double julian_time, double time_step, object accelerations)
    cpdef object state_update(self, double t, object z, object params)
    cpdef Vector3 compute_acceleration(Rigidbody self, double julian_date, Vector3 position, object accelerations)
    cpdef void compute_attitude_acceleration(Rigidbody self, double julian_date, object accelerations)
