#root.pxd
#distutils: language = c++

ctypedef double (*KeplerEquation)(double d, double v0, double v1, double v2, double v3, double v4)   
ctypedef double (*TestEquation)(double d)   

#cdef double call_kepler_equation(KeplerEquation ke, double d, double v0, double v1, double v2, double v3, double v4)
        
#ctypedef double (*KepEccentric)(double& de, double& dm, double& sigma0, double& sqrt_a, double& a, double& r)        
#ctypedef double (*KepHyperbolic)(double& dh, double& dn, double& sigma0, double& sqrt_a, double& a, double& r)    
#ctypedef double (*KepUniversal)(double& ds, double& dt, double& r0, double& v0, double& alpha, double& mu)
cdef class RootFunctionBinding:
    cdef double execute(RootFunctionBinding self, double x)

cdef class TestEquationBinding(RootFunctionBinding):
    cdef TestEquation _eq
    cdef double execute(TestEquationBinding self, double x)
       
cdef class KeplerEquationBinding(RootFunctionBinding):
    cdef KeplerEquation _eq
    cdef double _v0
    cdef double _v1
    cdef double _v2
    cdef double _v3
    cdef double _v4    
    cdef double execute(KeplerEquationBinding self, double x)
    
cdef TestEquationBinding CreateTestEquationBinding(TestEquation te)
cdef KeplerEquationBinding CreateKeplerEquationBinding(KeplerEquation ke, double v0, double v1, double v2, double v3, double v4 )
cdef object bracket_and_solve_root(RootFunctionBinding f, double guess, double factor, bint rising, int max_iter)
cdef object toms748_solve(RootFunctionBinding f, double ax, double bx, double fax, double fbx, int max_iter)
    