# -*- coding: utf-8 -*-
# -----------------------------------------------------------------------------
# Copyright (c) 2016, Brian Thorpe. All Rights Reserved.
# See LICENSE.txt for more info.
# -----------------------------------------------------------------------------
# Float

cdef struct float2:
    float x
    float y

cdef struct float3:
    float x
    float y
    float z

cdef struct float4:
    float x
    float y
    float z
    float w

cdef struct float16:
    # Stores a Matrix4f  Column Major Format stored as [Col0,Col1,Col2,Col3]
    # mRowCol
    float m00
    float m10
    float m20
    float m30
    float m01
    float m11
    float m21
    float m31
    float m02
    float m12
    float m22
    float m32
    float m03
    float m13
    float m23
    float m33

cdef struct rectf:
    float min_x
    float min_y
    float max_x
    float max_y

# Double

cdef struct double2:
    double x
    double y

cdef struct double3:
    double x
    double y
    double z

cdef struct double4:
    double x
    double y
    double z
    double w

cdef struct double16:
    # Stores a Matrix4 Column Major Format stored as [Col0,Col1,Col2,Col3]
    # mRowCol
    double m00
    double m10
    double m20
    double m30
    double m01
    double m11
    double m21
    double m31
    double m02
    double m12
    double m22
    double m32
    double m03
    double m13
    double m23
    double m33

# Integer

cdef struct recti:
    int x
    int y
    int width
    int height
