from cymath.matrix4f cimport Matrix4f
from cymath.math_structs cimport float3

cdef class Vector3f:
    cdef float3 _vector
    cpdef float magnitude_squared(self)    
    cpdef float magnitude(self)
    cpdef float dot(self, Vector3f other)
    cpdef Vector3f cross(Vector3f self, Vector3f other)
    cpdef Vector3f add(self, Vector3f other)    
    cpdef Vector3f subtract(self, Vector3f other)
    cpdef Vector3f multiply(self, float scalar)
    cpdef Vector3f divide(self, float scalar)
    cpdef Vector3f normalize(self)
    cpdef Vector3f negate(self)
    cpdef float angle_between(self, Vector3f other)
    cpdef float signed_angle_between(self, Vector3f other, Vector3f normal)
    cpdef Vector3f transform(self, Matrix4f matrix)
    cdef float* to_ptr(self)
    cpdef _cp_richcmp(self, Vector3f other, int op)
     
    #TODO:
    cpdef Vector3f catmullrom(Vector3f value1, Vector3f value2, Vector3f value3, Vector3f value4, float amount)
    cpdef float distance(Vector3f vector1, Vector3f vector2)
    cpdef float distance_squared(Vector3f value1, Vector3f value2)
    cpdef Vector3f hermite(Vector3f value1, Vector3f tangent1, Vector3f value2, Vector3f tangent2, float amount)
    cpdef Vector3f smooth_step(Vector3f value1, Vector3f value2, float amount)
    cpdef Vector3f reflect(Vector3f vector, Vector3f normal)
    cpdef Vector3f clamp(Vector3f self, Vector3f vector_min, Vector3f vector_max)
    cpdef Vector3f min(Vector3f self, Vector3f other)
    cpdef Vector3f max(Vector3f self, Vector3f other)

        