# -*- coding: utf-8 -*-
# -----------------------------------------------------------------------------
# Copyright (c) 2016, Brian Thorpe. All Rights Reserved.
# See LICENSE.txt for more info.
# -----------------------------------------------------------------------------
from libc.math cimport sqrt, acos, atan2
from cymath.math_structs cimport double4
from cymath.matrix4 cimport Matrix4
from cymath.vector2 cimport Vector2
from cymath.vector3 cimport Vector3
from cymath.vector4f cimport Vector4f


cdef class Vector4:
    cdef double4 _vector
    cpdef double magnitude_squared(self)    
    cpdef double magnitude(self)
    cpdef double dot(self, Vector4 other)
    cpdef Vector4 add(self, Vector4 other)    
    cpdef Vector4 subtract(self, Vector4 other)
    cpdef Vector4 multiply(self, double scalar)
    cpdef Vector4 normalize(self)
    cpdef Vector4 negate(self)
    cpdef Vector4 transform(self, Matrix4 matrix)
    cpdef Vector4f to_float(self)
    cpdef _cp_richcmp(self, Vector4 other, int op)
    cdef double* to_ptr(self)

