from cymath.vector3f cimport Vector3f
from cymath.matrix4f cimport Matrix4f
from cymath.math_structs cimport float4
    
cdef class Vector4f:
    cdef float4 _vector
    cpdef float magnitude_squared(self)    
    cpdef float magnitude(self)
    cpdef float dot(self, Vector4f other)
    cpdef Vector4f add(self, Vector4f other)    
    cpdef Vector4f subtract(self, Vector4f other)
    cpdef Vector4f multiply(self, float scalar)
    cpdef Vector4f multiply_element(self, Vector4f other)
    cpdef Vector4f normalize(self)
    cpdef Vector4f negate(self)
    cpdef Vector4f transform(self, Matrix4f matrix)
    cdef float* to_ptr(self)
    cpdef _cp_richcmp(self, Vector4f other, int op)